 /**
 * Sample React Native App
 * https://github.com/facebook/react-native
 *
 * @format
 * @flow
 */

import React, {Component} from 'react';
import {AppRegistry,Platform,AppState, StyleSheet, View, Text, Modal, Button, TouchableOpacity, Alert, NativeModules, NativeEventEmitter, Image} from 'react-native';
import { MrzScannerConstants } from 'react-native-mrzscannerlib';

const MrzApp= NativeModules.RNMrzscannerlib;
const EventEmitter = new NativeEventEmitter(MrzApp);
var subscription;



export default class App extends Component<Props> {
  constructor() {
    super()
    this.state = {
      value : '',
    }
  }


componentDidMount(){   
      subscription=EventEmitter.addListener
      ('successfulScanEmittedEvent',
        (body) => 
         console.log("Results" + body.surname,
                                 body.document_type_readable,
                                 body.issuing_country,
                                 body.surname,
                                 body.document_number,
                                 body.nationality,
                                 body.dob_raw,
                                 body.dob_readable,
                                 body.sex )
    );
       subscription=EventEmitter.addListener
       ('successfulDocumentScanEmittedEvent', (body) => { 
        this.setState({value : body});
       }
    );
    }


     componentWillDismount(){
    subscription.remove();
  }

  render(){   
    MrzApp.registerWithLicenseKey("")

    return(
      <View style={styles.container}>
      
        <Button
          title="MRZ Scanner"
          onPress={() => {
          MrzApp.setMaxThreads(MrzScannerConstants.MAX_THREADS.TWO)
          MrzApp.setScannerType(MrzScannerConstants.SCANNER_TYPE.MRZ)
          MrzApp.startScanner()


        }}/>

        <Button
          title="Image ID Scanner"
          onPress={() => {
         MrzApp.setMaxThreads(MrzScannerConstants.MAX_THREADS.TWO)
         MrzApp.setScannerType(MrzScannerConstants.SCANNER_TYPE.DOCUMENT_IMAGE_ID)
         MrzApp.startScanner()
            Alert.alert(
                "Alert Title",
                "Alert Msg",
                [ { text: "Cancel Scanner", onPress: () => MrzApp.closeScanner()
                },
                  { text: "Resume Scanner", onPress: () =>  MrzApp.resumeScanner() }
                ],
                { cancelable: true }
              );
                    

        }}/>
        <Button
          title="Image Passport Scanner"
          onPress={() => {
          MrzApp.setMaxThreads(MrzScannerConstants.MAX_THREADS.TWO)
          MrzApp.setScannerType(MrzScannerConstants.SCANNER_TYPE.DOCUMENT_IMAGE_PASSPORT)
          MrzApp.startScanner()
      

        }}/>
       
          <Button
          title="Scan from Gallery"
          onPress={() => {
         MrzApp.scanFromGallery()

        }}/>
        <Image style={{width: '100%',height: 350}} resizeMode= 'contain' source={{uri: `data:image/png;base64,${this.state.value}`}} />

      </View>

         );
   }
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    gap: 30,
    justifyContent: 'center',
    alignItems: 'center',
    backgroundColor: '#F5FCFF',
  },
  welcome: {
    fontSize: 20,
    textAlign: 'center',
    margin: 10,
  },
  instructions: {
    textAlign: 'center',
    color: '#333333',
    marginBottom: 5,
  },
});
